%========================

clear all
%===================
% I = % I = IL - Io * (exp(q*V/nkT) - 1)
IL = 1.0; % amp
Io = 1e-10; % amp 1e-10
nkT = 0.025 ; % volts
q = .9 ; %coulombs

Rser = 0.005;
Rsh = 0.9;
%I = IL - Io * (exp(q*(V+I*Rser)/nkT)) - (V+I*Rser)/Rsh ;
%===================
%total fit
figure(1)
clf

%========================================================
%START settable inputs
%========================================================
%data set Sasha
%the voltages
V=[0.35
1.23
1.3
3.2
4.16
5.08
7.38
9.35
9.85
12
13.2
14.4
14.9
15
15.2
15.3
15.6
15.6
15.8
16.1
16.3
16.5
16.7
16.8
16.9
17.5
18
18.3
19
19.2
];

%the measured current
I=[1.028
1.022
1.024
0.98
0.964
0.94
0.844
0.754
0.73
0.614
0.546
0.442
0.412
0.41
0.384
0.376
0.358
0.352
0.338
0.318
0.3
0.286
0.27
0.254
0.246
0.198
0.138
0.11
0.024
0.012
];

V = V/29.5 ; %30
plot(V,I, 'o')
hold on
%I = IL - Io * (exp(q*(V+I*Rser)/nkT)) - (V+I*Rser)/Rsh ;
% now, take I,V and compute new I using Rser and Rsh
Iinit = I; 
%plot(V,Iinit);
%
%Inew = IL - Io * (exp(q*V/nkT) - 1)  ;
Inew = IL - Io * (exp(q*(V+Iinit*Rser)/nkT )) - (V+Iinit*Rser)/Rsh ;
Inew = IL - Io * (exp(q*(V+Inew*Rser)/nkT )) - (V+Inew*Rser)/Rsh ;
Inew = IL - Io * (exp(q*(V+Inew*Rser)/nkT )) - (V+Inew*Rser)/Rsh ;
Inew = IL - Io * (exp(q*(V+Inew*Rser)/nkT )) - (V+Inew*Rser)/Rsh ;
Inew = IL - Io * (exp(q*(V+Inew*Rser)/nkT )) - (V+Inew*Rser)/Rsh ;


plot(V,Inew, 'r*')

var = sum(abs(Iinit - Inew))/30